diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index 836ffd6e9..ffcd2c3d3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -22,15 +22,18 @@ import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 import java.util.Objects;
@@ -266,7 +269,7 @@ public final class Block<T extends BlockLogic>
         return new ItemStack(this);
     }
 
-    public static boolean getIsLitInteriorSurface(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public static boolean getIsLitInteriorSurface(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = source.getBlock(tilePos);
         return block != null && block.isLitInteriorSurface;
     }
@@ -300,22 +303,22 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceOnSurfaceOnCondition(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.logic.canPlaceOnSurfaceOnCondition(world, tilePos);
     }
 
     @Override
-    public boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public boolean renderAsNormalBlockOnCondition(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.renderAsNormalBlockOnCondition(source, tilePos);
     }
 
     @Override
-    public boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceOnSurface(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.logic.canPlaceOnSurface(world, tilePos);
     }
 
     @Override
-    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity) {
+    public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
         return this.logic.getBreakResult(world, dropCause, tilePos, data, tileEntity);
     }
 
@@ -325,52 +328,52 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public @NotNull AABB getBounds() {
+    public @NotNull AABBdc getBounds() {
         return this.logic.getBounds();
     }
 
     @Override
-    public @NotNull AABB getBoundsRaw() {
+    public @NotNull AABBd getBoundsRaw() {
         return this.logic.getBoundsRaw();
     }
 
     @Override
-    public float getBrightness(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public float getBrightness(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.getBrightness(source, tilePos);
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public int getLightmapCoord(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.getLightmapCoord(source, tilePos);
     }
 
     @Override
-    public float getAmbientOcclusionStrength(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public float getAmbientOcclusionStrength(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.getAmbientOcclusionStrength(source, tilePos);
     }
 
     @Override
-    public @NotNull AABB getSelectionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getSelectionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.getSelectionAABB(source, tilePos);
     }
 
     @Override
-    public @Nullable BoundingVolume getBoundingVolume(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public @Nullable BoundingVolume getBoundingVolume(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.logic.getBoundingVolume(world, tilePos);
     }
 
     @Override
-    public void getCollisionAABBs(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull AABB aabb, final @NotNull List<@NotNull AABB> aabbList) {
+    public void getCollisionAABBs(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull AABBdc aabb, final @NotNull List<@NotNull AABBdc> aabbList) {
         this.logic.getCollisionAABBs(world, tilePos, aabb, aabbList);
     }
 
     @Override
-    public boolean collidesWithEntity(final @NotNull Entity entity, final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean collidesWithEntity(final @NotNull Entity entity, final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.logic.collidesWithEntity(entity, world, tilePos);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.getCollisionAABB(source, tilePos);
     }
 
@@ -395,17 +398,17 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         this.logic.updateTick(world, tilePos, rand, false);
     }
 
     @Override
-    public void animationTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand) {
+    public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
         this.logic.animationTick(world, tilePos, rand);
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         this.logic.onNeighborChanged(world, tilePos, id);
     }
 
@@ -415,7 +418,7 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
         if (this.isEntityTile && !disableNormalEntityLogic && this.entitySupplier != null) {
             world.setTileEntity(tilePos, this.entitySupplier.get());
         }
@@ -423,13 +426,13 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         this.logic.onRemoved(world, tilePos, data);
         if (this.isEntityTile && !disableNormalEntityLogic) {
             if (!world.isClientSide) {
                 final @Nullable TileEntity tileEntity = world.getTileEntity(tilePos);
                 if (tileEntity != null) {
-                    tileEntity.dropContents(world, tilePos.x, tilePos.y, tilePos.z);
+                    tileEntity.dropContents(world, tilePos.x(), tilePos.y(), tilePos.z());
                 }
             }
             world.removeTileEntity(tilePos);
@@ -437,12 +440,12 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) {
+    public void onDestroyedByPlayer(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final int data, final @NotNull Player player, final @Nullable Item item) {
         this.logic.onDestroyedByPlayer(world, tilePos, side, data, player, item);
     }
 
     @Override
-    public float getStrength(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Player player) {
+    public float getStrength(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Player player) {
         return this.logic.getStrength(world, tilePos, side, player);
     }
 
@@ -457,57 +460,57 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Vec3 start, final @NotNull Vec3 end, final boolean useSelectionAABB) {
+    public @Nullable HitResult collisionRayTrace(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final boolean useSelectionAABB) {
         return this.logic.collisionRayTrace(world, tilePos, start, end, useSelectionAABB);
     }
 
     @Override
-    public void onDestroyedByExplosion(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void onDestroyedByExplosion(final @NotNull World world, final @NotNull TilePosc tilePos) {
         this.logic.onDestroyedByExplosion(world, tilePos);
     }
 
     @Override
-    public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return this.logic.canPlaceOnSide(world, tilePos, side);
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.logic.canPlaceAt(world, tilePos);
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         return this.logic.onInteracted(world, tilePos, player, side, xHit, yHit);
     }
 
     @Override
-    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
+    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
         this.logic.onActivatorInteracted(world, tilePos, activator, direction);
     }
 
     @Override
-    public void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity walker) {
+    public void onEntityWalkedOn(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity walker) {
         this.logic.onEntityWalkedOn(world, tilePos, walker);
     }
 
     @Override
-    public void onAttacked(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onAttacked(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
         this.logic.onAttacked(world, tilePos, player, side, xHit, yHit);
     }
 
     @Override
-    public void onEntityInside(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity, final @NotNull Vec3 velocity) {
-        this.logic.onEntityInside(world, tilePos, entity, velocity);
+    public void onEntityInside(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity, final @NotNull Vector3d velocityDirection) {
+        this.logic.onEntityInside(world, tilePos, entity, velocityDirection);
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.getBoundsFromState(source, tilePos);
     }
 
     @Override
-    public boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return this.logic.isEmittingSignal(source, tilePos, side);
     }
 
@@ -517,42 +520,42 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public void onEntityCollision(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity) {
+    public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
         this.logic.onEntityCollision(world, tilePos, entity);
     }
 
     @Override
-    public boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return this.logic.isEmittingDirectSignal(world, tilePos, side);
     }
 
     @Override
-    public void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity) {
+    public void onHarvest(final @NotNull World world, final @NotNull Player player, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity) {
         this.logic.onHarvest(world, player, tilePos, data, tileEntity);
     }
 
     @Override
-    public void dropWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePos tilePos, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player) {
+    public void dropWithCause(final @NotNull World world, final @NotNull EnumDropCause dropCause, final @NotNull TilePosc tilePos, final int data, final @Nullable TileEntity tileEntity, final @Nullable Player player) {
         this.logic.dropWithCause(world, dropCause, tilePos, data, tileEntity, player);
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return this.logic.getSupport(world, tilePos, side);
     }
 
     @Override
-    public boolean canStay(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.logic.canStay(world, tilePos);
     }
 
     @Override
-    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         this.logic.onPlacedByMob(world, tilePos, side, mob, xHit, yHit);
     }
 
     @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         this.logic.onPlacedOnSide(world, tilePos, side, xHit, yHit);
     }
 
@@ -562,32 +565,32 @@ public final class Block<T extends BlockLogic>
     }
 
     @Override
-    public void triggerEvent(final @NotNull World world, final @NotNull TilePos tilePos, final int index, final int data) {
+    public void triggerEvent(final @NotNull World world, final @NotNull TilePosc tilePos, final int index, final int data) {
         this.logic.triggerEvent(world, tilePos, index, data);
     }
 
     @Override
-    public int getPistonPushReaction(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.logic.getPistonPushReaction(world, tilePos);
     }
 
     @Override
-    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         return this.logic.getPlacedData(player, itemStack, world, tilePos, side, xHit, yHit);
     }
 
     @Override
-    public boolean isClimbable(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean isClimbable(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.logic.isClimbable(world, tilePos);
     }
 
     @Override
-    public boolean isEquivalent(final @NotNull World world, final @NotNull TilePos thisPos, final @NotNull TilePos thatPos) {
+    public boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos) {
         return this.logic.isEquivalent(world, thisPos, thatPos);
     }
 
     @Override
-    public @NotNull Side getAttachedSide(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull Side getAttachedSide(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return this.logic.getAttachedSide(source, tilePos);
     }
 
